import { resultSuccess } from '../_util';
import { MockMethod } from 'vite-plugin-mock';
import { SendManage, MsgType, MsgResult } from './socket';

export default [
  {
    url: '/basic-api/table/EditItem',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      //console.log(req.url);
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      //const needRefresh = url.searchParams.get('NeedRefresh') || 'False';
      res.setHeader('Content-Type', 'text/plain');
      const data = {
        UniqueID: url.searchParams.get('UniqueID'),
        OwnerID: Number(url.searchParams.get('OwnerID')),
        ItemName: url.searchParams.get('ItemName'),
        Store: url.searchParams.get('Store'),
        Position: Number(url.searchParams.get('Position')),
        Count: Number(url.searchParams.get('Count')),
        MC: Number(url.searchParams.get('MC')),
        SC: Number(url.searchParams.get('SC')),
        AC: Number(url.searchParams.get('AC')),
        DC: Number(url.searchParams.get('DC')),
        MAC: Number(url.searchParams.get('MAC')),
        Accuracy: Number(url.searchParams.get('Accuracy')),
        Agility: Number(url.searchParams.get('Agility')),
        BagWeight: Number(url.searchParams.get('BagWeight')),
        WearWeight: Number(url.searchParams.get('WearWeight')),
        HandWeight: Number(url.searchParams.get('HandWeight')),
        FireAC: Number(url.searchParams.get('FireAC')),
        WindAC: Number(url.searchParams.get('WindAC')),
        IceAC: Number(url.searchParams.get('IceAC')),
        LightAC: Number(url.searchParams.get('LightAC')),
        HolyAC: Number(url.searchParams.get('HolyAC')),
        DarkAC: Number(url.searchParams.get('DarkAC')),
        PhantomAC: Number(url.searchParams.get('PhantomAC')),
        FireMAC: Number(url.searchParams.get('FireMAC')),
        WindMAC: Number(url.searchParams.get('WindMAC')),
        IceMAC: Number(url.searchParams.get('IceMAC')),
        LightMAC: Number(url.searchParams.get('LightMAC')),
        HolyMAC: Number(url.searchParams.get('HolyMAC')),
        DarkMAC: Number(url.searchParams.get('DarkMAC')),
        PhantomMAC: Number(url.searchParams.get('PhantomMAC')),
        WpLevelExp: Number(url.searchParams.get('WpLevelExp')),
        HP: Number(url.searchParams.get('HP')),
        MP: Number(url.searchParams.get('MP')),
        Luck: Number(url.searchParams.get('Luck')),
        MagicResist: Number(url.searchParams.get('MagicResist')),
        PoisonResist: Number(url.searchParams.get('PoisonResist')),
        HealthRecovery: Number(url.searchParams.get('HealthRecovery')),
        ManaRecovery: Number(url.searchParams.get('ManaRecovery')),
        PoisonRecovery: Number(url.searchParams.get('PoisonRecovery')),
        CriticalRate: Number(url.searchParams.get('CriticalRate')),
        CriticalDamage: Number(url.searchParams.get('CriticalDamage')),
        Freezing: Number(url.searchParams.get('Freezing')),
        PoisonAttack: Number(url.searchParams.get('PoisonAttack')),
        Reflect: Number(url.searchParams.get('Reflect')),
        MaxAcRate: Number(url.searchParams.get('MaxAcRate')),
        MaxMacRate: Number(url.searchParams.get('MaxMacRate')),
        Parry: Number(url.searchParams.get('Parry')),
        IgnoreAC: Number(url.searchParams.get('IgnoreAC')),
        IgnoreMAC: Number(url.searchParams.get('IgnoreMAC')),
        DropProtect: Number(url.searchParams.get('DropProtect')),
      };
      console.log(JSON.stringify(data));
      let result;
      try {
        const timeKey: number = Number(url.searchParams.get('TimeKey'));
        const timestamp = Date.parse(new Date().toString());
        console.log('时间戳差额：' + (timestamp - timeKey));
        if (timestamp - timeKey > 3000) {
          result = new MsgResult();
          result.StatusCode = 0;
          result.Message = 'key过期';
          res.statusCode = 400;
        } else {
          result = await SendManage(data, MsgType.EditItem);
        }
      } catch (error) {
        console.log(error);
        result = new MsgResult();
        result.StatusCode = 0;
        result.Message = '连接发生异常：' + error;
        res.statusCode = 400;
      } finally {
        console.log(result);
        res.end(JSON.stringify(resultSuccess(result)));
      }
    },
  },
  {
    url: '/basic-api/table/DeleteItem',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      res.setHeader('Content-Type', 'text/plain');
      const data = {
        UniqueID: url.searchParams.get('UniqueID'),
        OwnerID: Number(url.searchParams.get('OwnerID')),
        Store: url.searchParams.get('Store'),
      };
      console.log(JSON.stringify(data));
      let result;
      try {
        const timeKey: number = Number(url.searchParams.get('TimeKey'));
        const timestamp = Date.parse(new Date().toString());
        console.log('时间戳差额：' + (timestamp - timeKey));
        if (timestamp - timeKey > 3000) {
          result = new MsgResult();
          result.StatusCode = 0;
          result.Message = 'key过期';
          res.statusCode = 400;
        } else {
          result = await SendManage(data, MsgType.DeleteItem);
        }
      } catch (error) {
        console.log(error);
        result = new MsgResult();
        result.StatusCode = 0;
        result.Message = '连接发生异常：' + error;
        res.statusCode = 400;
      } finally {
        console.log(result);
        res.end(JSON.stringify(resultSuccess(result)));
      }
    },
  },
  {
    url: '/basic-api/table/SendItem2Mail',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      res.setHeader('Content-Type', 'text/plain');
      const data = {
        UniqueID: url.searchParams.get('UniqueID'),
        OwnerID: Number(url.searchParams.get('OwnerID')),
        Store: url.searchParams.get('Store'),
      };
      console.log(JSON.stringify(data));
      let result;
      try {
        const timeKey: number = Number(url.searchParams.get('TimeKey'));
        const timestamp = Date.parse(new Date().toString());
        console.log('时间戳差额：' + (timestamp - timeKey));
        if (timestamp - timeKey > 3000) {
          result = new MsgResult();
          result.StatusCode = 0;
          result.Message = 'key过期';
          res.statusCode = 400;
        } else {
          result = await SendManage(data, MsgType.SendItemToMail);
        }
      } catch (error) {
        console.log(error);
        result = new MsgResult();
        result.StatusCode = 0;
        result.Message = '连接发生异常：' + error;
        res.statusCode = 400;
      } finally {
        console.log(result);
        res.end(JSON.stringify(resultSuccess(result)));
      }
    },
  },
  {
    url: '/basic-api/table/SendItem2Inven',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      res.setHeader('Content-Type', 'text/plain');
      const data = {
        UniqueID: url.searchParams.get('UniqueID'),
        OwnerID: Number(url.searchParams.get('OwnerID')),
        Store: url.searchParams.get('Store'),
      };
      console.log(JSON.stringify(data));
      let result;
      try {
        const timeKey: number = Number(url.searchParams.get('TimeKey'));
        const timestamp = Date.parse(new Date().toString());
        console.log('时间戳差额：' + (timestamp - timeKey));
        if (timestamp - timeKey > 3000) {
          result = new MsgResult();
          result.StatusCode = 0;
          result.Message = 'key过期';
          res.statusCode = 400;
        } else {
          result = await SendManage(data, MsgType.SendItemToInventory);
        }
      } catch (error) {
        console.log(error);
        result = new MsgResult();
        result.StatusCode = 0;
        result.Message = '连接发生异常：' + error;
        res.statusCode = 400;
      } finally {
        res.end(JSON.stringify(resultSuccess(result)));
        console.log(result);
      }
    },
  },
] as MockMethod[];
