import { resultSuccess } from '../_util';
import { MockMethod } from 'vite-plugin-mock';
import { SendManage, MsgType, MsgResult } from './socket';
import { ServerAddress } from './query';

export default [
  {
    url: '/basic-api/table/GiveItem',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      //console.log(req.url);
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      //const needRefresh = url.searchParams.get('NeedRefresh') || 'False';
      res.setHeader('Content-Type', 'text/plain');

      const timeKey: number = Number(url.searchParams.get('TimeKey'));
      const timestamp = Date.parse(new Date().toString());
      console.log('时间戳差额：' + (timestamp - timeKey));
      const data = {
        ItemName: url.searchParams.get('ItemName'),
        Count: url.searchParams.get('Count'),
        PlayerName: url.searchParams.get('PlayerName'),
      };
      let result;
      try {
        if (timestamp - timeKey > 3000) {
          result = new MsgResult();
          result.StatusCode = 0;
          result.Message = 'key过期';
          res.statusCode = 400;
        } else {
          result = await SendManage(
            data,
            MsgType.GiveItem,
            ServerAddress(url.searchParams.get('ServerName') || '龙行大运'),
          );
        }
      } catch (error) {
        console.log(error);
        result = new MsgResult();
        result.StatusCode = 0;
        result.Message = '连接发生异常：' + error;
        res.statusCode = 400;
      } finally {
        console.log(result);
        res.end(JSON.stringify(resultSuccess(result)));
      }
    },
  },
] as MockMethod[];
