import { MockMethod } from 'vite-plugin-mock';
import { resultPageSuccess, resultSuccess } from '../_util';
import { databaseName, query } from './query';
// 接收一个sql语句 以及所需的values
// 这里接收第二参数values的原因是可以使用mysql的占位符 '?'
// 比如 query(`select * from my_database where id = ?`, [1])

async function RefreshItemCountList(ItemName: string) {
  const queryStr =
    'select it.ItemName,sum(it.Count) as Count,c.Name from ' +
    databaseName() +
    '.items it left join ' +
    databaseName() +
    ".characterinfo c on it. ownerid=c.indexid where it.itemName='" +
    ItemName +
    "' and it.Store<>'Mail' group by it.ownerid order by Count desc";
  console.log('QueryStr: ', queryStr);
  const results = await query(queryStr, '');
  let i: number;
  totalCount = 0;
  for (i = 0; i < results.length; i++) {
    const data = results[i];
    totalCount += data.Count;
    if (ItemCountList.length > i) {
      ItemCountList[i] = data;
    } else {
      ItemCountList.push(data);
    }
  }
  if (ItemCountList.length > results.length) {
    ItemCountList.splice(results.length, ItemCountList.length - results.length);
  }

  console.log('ResultCount: ', ItemCountList.length);
  console.log('TotalCount: ', totalCount);
  return results;
}

const ItemCountList: any[] = [];
let totalCount = 0;
export default [
  {
    url: '/basic-api/table/ItemCountList',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      const page = Number(url.searchParams.get('page'));
      const needRefresh = url.searchParams.get('NeedRefresh') || 'False';
      if (needRefresh == 'True') {
        await RefreshItemCountList(url.searchParams.get('ItemName') || '');
      }
      res.setHeader('Content-Type', 'text/plain');
      res.statusCode = 200;
      res.end(
        JSON.stringify(
          resultPageSuccess(page, Number(url.searchParams.get('pageSize')), ItemCountList),
        ),
      );
    },
  },
  {
    url: '/basic-api/table/ItemTotalCount',
    timeout: 100,
    method: 'get',
    response: () => {
      return resultSuccess(totalCount);
    },
  },
] as MockMethod[];
