import { MockMethod } from 'vite-plugin-mock';
import { resultPageSuccess, resultSuccess } from '../_util';
import { databaseName, query } from './query';
// 接收一个sql语句 以及所需的values
// 这里接收第二参数values的原因是可以使用mysql的占位符 '?'
// 比如 query(`select * from my_database where id = ?`, [1])

async function RefreshCharacterItemsList(OwnerID = '', OwnerName = '', Store: string) {
  let queryStr =
    'Select t.*,tt.name as CharacterName from ' +
    databaseName() +
    '.Items t left join ' +
    databaseName() +
    '.CharacterInfo tt on t.OwnerID=tt.IndexiD where 1=1 ';
  if (Store == 'Mail') {
    queryStr =
      'Select t.*,tt.name as CharacterName  from ' +
      databaseName() +
      '.Items t left join ' +
      databaseName() +
      '.mail m on t.OwnerID=m.MailID left join ' +
      databaseName() +
      '.CharacterInfo tt on m.RecipientIndex=tt.IndexiD where 1=1';
  }
  console.log('OwnerID:' + OwnerID);
  if (OwnerID != '') {
    if (Store == 'Mail') {
      queryStr += " and m.RecipientIndex='" + OwnerID + "'";
    } else {
      queryStr += " and t.OwnerID='" + OwnerID + "'";
    }
  }

  if (OwnerName != '') {
    queryStr += " and tt.Name='" + OwnerName + "'";
  }
  queryStr += " and t.Store='" + Store + "'";
  queryStr += ' order by t.position';

  queryStr += ' limit 10000';
  console.log('QueryStr: ', queryStr);
  const results = await query(queryStr, '');
  console.log('QueryCount: ', results.length);
  let i: number;
  for (i = 0; i < results.length; i++) {
    const data = results[i];
    //console.log('Data: ', data);
    if (CharacterItemsList.length > i) {
      CharacterItemsList[i] = data;
    } else {
      CharacterItemsList.push(data);
    }
  }
  if (CharacterItemsList.length > results.length) {
    CharacterItemsList.splice(results.length, CharacterItemsList.length - results.length);
  }

  console.log('ResultCount: ', CharacterItemsList.length);
  return results;
}

const CharacterItemsList: any[] = [];

export default [
  {
    url: '/basic-api/table/CharacterItemsList',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      const page = Number(url.searchParams.get('page'));
      const needRefresh = url.searchParams.get('NeedRefresh') || 'False';
      if (needRefresh == 'True') {
        await RefreshCharacterItemsList(
          url.searchParams.get('OwnerID') || '',
          url.searchParams.get('OwnerName') || '',
          url.searchParams.get('Store') || '',
        );
      }
      res.setHeader('Content-Type', 'text/plain');
      res.statusCode = 200;
      res.end(
        JSON.stringify(
          resultPageSuccess(page, Number(url.searchParams.get('pageSize')), CharacterItemsList),
        ),
      );
    },
    // response: ({ url, query, headers, body }) => {
    //   const { page = 1, pageSize = 200 } = query;
    //   // console.log('url: ', url);
    //   // console.log('query: ', query);
    //   // console.log('headers: ', headers);
    //   // console.log('body: ', body);
    //   await RefreshCharacterList(0, query.AccountID, query.Name);
    //   //console.log('CharacterList: ', CharacterList);
    //   return resultPageSuccess(page, pageSize, CharacterList); //{ Name: '123', Index: 123 }
    // },
  },
  {
    url: '/basic-api/table/GetItemByID',
    timeout: 100,
    method: 'get',
    rawResponse: async (req, res) => {
      const url = new URL(req.url || '', `http://${req.headers.host}`);
      const results = await GetItemsByID(Number(url.searchParams.get('UniqueID')));
      res.setHeader('Content-Type', 'text/plain');
      res.statusCode = 200;
      res.end(JSON.stringify(resultSuccess(results[0])));
    },
  },
] as MockMethod[];

async function GetItemsByID(UniqueID: number): Promise<any> {
  const queryStr =
    'Select t.*,tt.name as CharacterName from ' +
    databaseName() +
    '.Items t left join ' +
    databaseName() +
    '.CharacterInfo tt on t.OwnerID=tt.IndexiD where UniqueID=' +
    UniqueID;
  console.log('QueryStr:' + queryStr);
  const results = await query(queryStr, '');
  console.log('ResultCount:' + results.length);
  return results;
}
