import { defHttp } from '@/utils/http/axios';
import { DemoParams, DemoListGetResultModel, AccountListGetResultModel } from './model/tableModel';

enum Api {
  DEMO_LIST = '/table/getDemoList',
  DB_LIST = '/table/queryAccount',
}
/**
 * @description: Get sample list value
 */

export const demoListApi = (params: DemoParams) =>
  defHttp.get<DemoListGetResultModel>({
    url: Api.DEMO_LIST,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const dbListApi2 = (params: DemoParams) =>
  defHttp.get<AccountListGetResultModel>({
    url: Api.DB_LIST,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
