import { defHttp } from '@/utils/http/axios';
import { MsgResult } from 'mock/demo/socket';

enum Api {
  GiveItem = '/table/GiveItem',
  EditItem = '/table/EditItem',
  DeleteItem = '/table/DeleteItem',
  SendItemToMail = '/table/SendItem2Mail',
  SendItemToInventory = '/table/SendItem2Inven',
  EditDDrop = '/table/EditDDrop',
  KickPlayer = '/table/KickPlayer',
  BanPlayer = '/table/BanPlayer',
  UnbanPlayer = '/table/UnbanPlayer',
  SendHookQuestion = '/table/SendHookQuestion',
  ChangeHookSuspicionLevel = '/table/ChangeHookSuspicionLevel',
  AddBannedAddress = '/table/AddBannedAddress',
  ChangeServer = '/table/ChangeServer',
  GetServer = '/table/GetServer',
}
/**
 * @description: Get sample list value
 */

export const GiveItem = (params: any) =>
  defHttp.get<MsgResult>({
    url: Api.GiveItem,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const EditItem = (params: any) =>
  defHttp.get<MsgResult>({
    url: Api.EditItem,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const DeleteItem = (UniqueID: number, OwnerID: number, Store: string) =>
  defHttp.get<MsgResult>({
    url: Api.DeleteItem,
    params: {
      UniqueID: UniqueID,
      OwnerID: OwnerID,
      Store: Store,
      TimeKey: Date.parse(new Date().toString()),
    },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const SendItemToMail = (UniqueID: number, OwnerID: number, Store: string) =>
  defHttp.get<MsgResult>({
    url: Api.SendItemToMail,
    params: {
      UniqueID: UniqueID,
      OwnerID: OwnerID,
      Store: Store,
      TimeKey: Date.parse(new Date().toString()),
    },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const SendItemToInventory = (UniqueID: number, OwnerID: number, Store: string) =>
  defHttp.get<MsgResult>({
    url: Api.SendItemToInventory,
    params: {
      UniqueID: UniqueID,
      OwnerID: OwnerID,
      Store: Store,
      TimeKey: Date.parse(new Date().toString()),
    },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const EditDDrop = (PlayerID: number, MonsterName: string, Value: number) =>
  defHttp.get<MsgResult>({
    url: Api.EditDDrop,
    params: {
      PlayerID: PlayerID,
      MonsterName: MonsterName,
      Value: Value,
      TimeKey: Date.parse(new Date().toString()),
    },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const KickPlayer = (PlayerID: number) =>
  defHttp.get<MsgResult>({
    url: Api.KickPlayer,
    params: { PlayerID: PlayerID },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const BanPlayer = (AccountID: string) =>
  defHttp.get<MsgResult>({
    url: Api.BanPlayer,
    params: { AccountID: AccountID, TimeKey: Date.parse(new Date().toString()) },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const UnbanPlayer = (AccountID: string) =>
  defHttp.get<MsgResult>({
    url: Api.UnbanPlayer,
    params: { AccountID: AccountID, TimeKey: Date.parse(new Date().toString()) },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const SendHookQuestion = (AccountID: string) =>
  defHttp.get<MsgResult>({
    url: Api.SendHookQuestion,
    params: { AccountID: AccountID, TimeKey: Date.parse(new Date().toString()) },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const ChangeHookSuspicionLevel = (AccountID: string, value: number) =>
  defHttp.get<MsgResult>({
    url: Api.ChangeHookSuspicionLevel,
    params: { AccountID: AccountID, Value: value, TimeKey: Date.parse(new Date().toString()) },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const AddBannedAddress = (Address: string, Type: number) =>
  defHttp.get<MsgResult>({
    url: Api.AddBannedAddress,
    params: { Address: Address, Type: Type, TimeKey: Date.parse(new Date().toString()) },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const ChangeServer = (ServerName: string) =>
  defHttp.get<MsgResult>({
    url: Api.ChangeServer,
    params: { ServerName: ServerName, TimeKey: Date.parse(new Date().toString()) },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const GetServer = () =>
  defHttp.get<MsgResult>({
    url: Api.GetServer,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
