import { defHttp } from '@/utils/http/axios';
import {
  DemoParams,
  ItemsListGetResultModel,
  ItemsItem,
  DDropListGetResultModel,
  ItemCountListGetResultModel,
} from './model/itemsModel';

enum Api {
  DB_LIST = '/table/CharacterItemsList',
  DB_LIST2 = '/table/GetItemByID',
  DB_LIST3 = '/table/DDropList',
  DB_LIST4 = '/table/ItemCountList',
  ItemTotalCount = '/table/ItemTotalCount',
}
/**
 * @description: Get sample list value
 */

export const characterItemsList = (params: DemoParams) =>
  defHttp.get<ItemsListGetResultModel>({
    url: Api.DB_LIST,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const GetItemByID = (UniqueID: number) =>
  defHttp.get<ItemsItem>({
    url: Api.DB_LIST2,
    params: { UniqueID: UniqueID },
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const DDropList = (params: DemoParams) =>
  defHttp.get<DDropListGetResultModel>({
    url: Api.DB_LIST3,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

export const ItemCountList = (params: DemoParams) =>
  defHttp.get<ItemCountListGetResultModel>({
    url: Api.DB_LIST4,
    params,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });
export const ItemTotalCount = () =>
  defHttp.get<number>({
    url: Api.ItemTotalCount,
    headers: {
      // @ts-ignore
      ignoreCancelToken: true,
    },
  });

const totalCount = 0;

export function GetTotalCount() {
  return totalCount;
}
