import { BasicPageParams, BasicFetchResult } from '@/api/model/baseModel';
/**
 * @description: Request list interface parameters
 */
export type DemoParams = Partial<BasicPageParams>;
export interface ItemsItem {
  UniqueID: number;
  ItemIndex: number;
  OwnerID: number;
  Store: string;
  ItemName: string;
  Position: number;
  Count: number;
  MC: number;
  SC: number;
  AC: number;
  DC: number;
  MAC: number;
  Accuracy: number;
  Agility: number;
  BagWeight: number;
  WearWeight: number;
  HandWeight: number;
  FireAC: number;
  WindAC: number;
  IceAC: number;
  LightAC: number;
  HolyAC: number;
  DarkAC: number;
  PhantomAC: number;
  FireMAC: number;
  WindMAC: number;
  IceMAC: number;
  LightMAC: number;
  HolyMAC: number;
  DarkMAC: number;
  PhantomMAC: number;
  IR: number;
  IG: number;
  IB: number;
  WpLevelExp: number;
  HP: number;
  MP: number;
  AttackSpeed: number;
  Luck: number;
  MagicResist: number;
  PoisonResist: number;
  HealthRecovery: number;
  ManaRecovery: number;
  PoisonRecovery: number;
  CriticalRate: number;
  CriticalDamage: number;
  Freezing: number;
  PoisonAttack: number;
  RefineAdded: number;
  Reflect: number;
  MaxAcRate: number;
  MaxMacRate: number;
  Parry: number;
  IgnoreAC: number;
  IgnoreMAC: number;
  DropProtect: number;
  SuperRefineLevel: number;
}

/**
 * @description: Request list return value
 */
export type ItemsListGetResultModel = BasicFetchResult<ItemsItem>;

export interface DDropItem {
  PlayerID: number;
  PlayerName: string;
  MonsterName: string;
  Value: number;
}

export type DDropListGetResultModel = BasicFetchResult<DDropItem>;

export interface ItemCount {
  ItemName: string;
  Count: number;
  Name: string;
}

export type ItemCountListGetResultModel = BasicFetchResult<ItemCount>;
