import type { AppRouteModule } from '@/router/types';

import { LAYOUT } from '@/router/constant';
import { t } from '@/hooks/web/useI18n';

const works: AppRouteModule = {
  path: '/Work',
  name: 'Work',
  component: LAYOUT,
  redirect: '/Work/character',
  meta: {
    orderNo: 1,
    icon: 'ion:key-outline',
    title: t('routes.demo.Work.Work'),
  },

  children: [
    {
      path: 'character',
      name: 'character',
      component: () => import('@/views/Work/Character.vue'),
      meta: {
        title: t('routes.demo.Work.character'),
      },
    },
    {
      path: 'characterItems',
      name: 'characterItems',
      component: () => import('@/views/Work/CharacterItems.vue'),
      meta: {
        title: t('routes.demo.Work.characterItems'),
      },
    },
    {
      path: 'DDrop',
      name: 'DDrop',
      component: () => import('@/views/Work/DDropPoint.vue'),
      meta: {
        title: t('routes.demo.Work.DDrop'),
      },
    },
    {
      path: 'giveItem',
      name: 'giveItem',
      component: () => import('@/views/Work/GiveItem.vue'),
      meta: {
        title: t('routes.demo.Work.giveItem'),
      },
    },
    {
      path: 'characterbymac',
      name: 'characterbymac',
      component: () => import('@/views/Work/CharacterByMac.vue'),
      meta: {
        title: t('routes.demo.Work.characterbymac'),
      },
    },
    {
      path: 'editItem',
      name: 'editItem',
      component: () => import('@/views/Work/EditItem.vue'),
      meta: {
        title: t('routes.demo.Work.editItem'),
      },
    },
    {
      path: 'itemCount',
      name: 'itemCount',
      component: () => import('@/views/Work/ItemCountList.vue'),
      meta: {
        title: t('routes.demo.Work.itemCount'),
      },
    },
  ],
};

export default works;
