import { BasicColumn } from '@/components/Table';

export function GetItemsColumns(): BasicColumn[] {
  return [
    // {
    //   title: '编号',
    //   dataIndex: 'UniqueID',
    //   fixed: 'left',
    //   width: 60,
    // },
    // {
    //   title: '物品编号',
    //   dataIndex: 'ItemIndex',
    //   width: 60,
    // },
    // {
    //   title: '所有者ID',
    //   dataIndex: 'OwnerID',
    //   width: 60,
    // },
    {
      title: '物品名',
      dataIndex: 'ItemName',
      width: 120,
    },
    {
      title: '数量',
      dataIndex: 'Count',
      width: 40,
    },
    {
      title: '存储位置',
      dataIndex: 'Store',
      width: 100,
    },
    {
      title: '单元格号码',
      dataIndex: 'Position',
      width: 50,
    },
  ];
  //#region column
  // MC: number;
  // SC: number;
  // AC: number;
  // DC: number;
  // MAC: number;
  // Accuracy: number;
  // Agility: number;
  // BagWeight: number;
  // WearWeight: number;
  // HandWeight: number;
  // FireAC: number;
  // WindAC: number;
  // IceAC: number;
  // LightAC: number;
  // HolyAC: number;
  // DarkAC: number;
  // PhantomAC: number;
  // FireMAC: number;
  // WindMAC: number;
  // IceMAC: number;
  // LightMAC: number;
  // HolyMAC: number;
  // DarkMAC: number;
  // PhantomMAC: number;
  // IR: number;
  // IG: number;
  // IB: number;
  // WpLevelExp: number;
  // HP: number;
  // MP: number;
  // AttackSpeed: number;
  // Luck: number;
  // MagicResist: number;
  // PoisonResist: number;
  // HealthRecovery: number;
  // ManaRecovery: number;
  // PoisonRecovery: number;
  // CriticalRate: number;
  // CriticalDamage: number;
  // Freezing: number;
  // PoisonAttack: number;
  // RefineAdded: number;
  // Reflect: number;
  // MaxAcRate: number;
  // MaxMacRate: number;
  // Parry: number;
  // IgnoreAC: number;
  // IgnoreMAC: number;
  // DropProtect: number;
  // SuperRefineLevel: number;
  //#endregion
}

export function getItemCountColumns(): BasicColumn[] {
  return [
    {
      title: '姓名',
      dataIndex: 'Name',
      width: 120,
      fixed: 'left',
      maxWidth: 130,
    },
    {
      title: '数量',
      dataIndex: 'Count',
      width: 80,
      maxWidth: 130,
    },
    {
      title: '物品名',
      dataIndex: 'ItemName',
      width: 100,
      maxWidth: 130,
    },
  ];
}

export function getCharacterColumns(): BasicColumn[] {
  return [
    {
      title: '姓名',
      dataIndex: 'Name',
      width: 120,
      fixed: 'left',
      maxWidth: 130,
    },
    {
      title: '账号',
      dataIndex: 'AccountID',
      width: 120,
    },
    {
      title: '在线',
      dataIndex: 'IsOnline',
      width: 50,
    },
    {
      title: '封禁',
      dataIndex: 'Banned',
      width: 50,
    },
    {
      title: '等级',
      dataIndex: 'Level',
      width: 50,
    },
    {
      title: '职业',
      dataIndex: 'Class',
      width: 60,
    },
    {
      title: '性别',
      dataIndex: 'Gender',
      width: 50,
    },
    {
      title: '金币',
      dataIndex: 'Gold',
      width: 80,
    },
    {
      title: '最近登录IP',
      dataIndex: 'LastIP',
      width: 200,
    },
    {
      title: '最近登录Mac',
      dataIndex: 'LoginMac',
      width: 200,
    },
    {
      title: '最近离线时间',
      dataIndex: 'LastDate',
      width: 260,
    },
    {
      title: '最近登录时间',
      dataIndex: 'LoginDate',
      width: 260,
    },
    {
      title: '编号',
      dataIndex: 'IndexID',
      width: 100,
    },
    {
      title: '密码',
      dataIndex: 'Password',
      width: 160,
    },
    {
      title: '挂机嫌疑',
      dataIndex: 'HookSuspicionLevel',
      width: 80,
    },
  ];
}
export function getAccountColumns(): BasicColumn[] {
  return [
    {
      title: '编号',
      dataIndex: 'Index',
      fixed: 'left',
      width: 200,
    },
    {
      title: '姓名',
      dataIndex: 'Name',
      width: 150,
      filters: [
        { text: 'Male', value: 'male' },
        { text: 'Female', value: 'female' },
      ],
    },
  ];
}

export function getDDropColumns(): BasicColumn[] {
  return [
    {
      title: '角色ID',
      dataIndex: 'PlayerID',
      fixed: 'left',
      //defaultHidden: true,
      width: 200,
    },
    {
      title: '角色名',
      dataIndex: 'PlayerName',
      fixed: 'left',
      defaultHidden: true,
      width: 200,
    },
    {
      title: '怪物名',
      dataIndex: 'MonsterName',
      fixed: 'left',
      width: 200,
    },
    {
      title: '点数',
      dataIndex: 'Value',
      width: 150,
      edit: true,
      // 默认必填校验
      editRule: true,
    },
  ];
}
